=== core/data/geolocation/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

ADD_SUBDIRECTORY(editor)
ADD_SUBDIRECTORY(geoiface)
