=== core/libs/mlfoundation/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
# SPDX-FileCopyrightText: 2024      by Michael Miller, <michael underscore miller at msn dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

set(libmlpipeline_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/mlpipelinefoundation.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/mlpipelinepackagenotify.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/mlclassifierfoundation.cpp
)

include_directories(
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Gui,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Concurrent,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::CoreAddons,INTERFACE_INCLUDE_DIRECTORIES>
)

# Used by digikamcore
add_library(core_mlpipeline_obj OBJECT ${libmlpipeline_SRCS})

target_compile_definitions(core_mlpipeline_obj
                           PRIVATE
                           digikamcore_EXPORTS
)
