=== debian/changelog ===
digikam (4:8.6.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * No tab in license text (routine-update)
  * [bd66d05] Rebase patches

 -- Steve M. Robbins <smr@debian.org>  Sun, 16 Mar 2025 23:29:13 -0500
